<html><body bgcolor="#FFFFFF">

<table cellspacing="0" cellpadding="0" width="100%">
	<tr><td align="right">By Robert Kuster, March 2008</td></tr>
	<tr><td align="right"><a href="http://www.joomla.rkuster.com">www.joomla.rkuster.com</a></td></tr>
	</td></tr>
</table>


<h1>SectionEx</h1>
<p>
<ol>
	<li><a href="#1_about">About</a></li>
	<li><a href="#2_usage">Usage</a></li>	
	<li><a href="#3_examples">Examples</a>		
		<ul>
			<li><a href="#3_examples_1">Ordinary output</a></li>
			<li><a href="#3_examples_2">Output with expandable descriptions</a></li>
		</ul>		
	</li>
	<li><a href="#4_behind_the_scenes">Behind the Scenes</a></li>
	<li><a href="#5_faq">FAQ</a></li>
	<li><a href="#6_share_link">Share Your Link</a></li>
	<li><a href="#7_final_note">Final Note (<b>a must read!</b>)</a></li>
</ol>
</p>



<br />&nbsp;
<a name="1_about"></a>
<h2>1) About</h2>
<p>SectionEx will <b>list all articles within a section</b>, grouped by categories. It combines and extends Joomla!'s build in "Section Layout" and "Category List Layout". The output will have the following form:
<ul>
	<li>Category 1
		<ul>
			<li>Article 1-1</li>
			<li>Article 1-2</li>
			<li>Article 1-3</li>
		</ul>
	</li>
	<li>Category 2
		<ul>
			<li>Article 2-1</li>
			<li>Article 2-2</li>
			<li>Article 2-3</li>
		</ul>
	</li>
	<li>... </li>
	<li>Category n
		<ul>
			<li>Article n-1</li>
			<li>Article n-2</li>
			<li>Article n-3</li>
		</ul>
	</li>
</ul>
SectionEx is written for Joomla! 1.5 using its MVC (model-view-controller) architecture. It is not compatible with previous versions of Joomla!.
</p>


<br />&nbsp;
<a name="2_usage"></a>
<h2>2) Usage</h2>
<p>SectionEx has no administrative settings. It can be fully configured through menu parameters. To use it:

<ul>
	<li>Go to Menus</li>
	<li>Select a menu item</li>
	<li>Change menu item type to <b>SectionEx -> Section-Category-Article List</b></li>
	<li>Select a section from the parameter list on the right side</li>
	<li>Possibly adopt any other parameters</li>
	<li>Click Save</li>
</ul>
</p>


<br />
<a name="3_examples"></a>
<h2>3) Examples</h2>
<ul>
	<li><a name="3_examples_1"></a><h3>Ordinary output</h3>
	<?php  echo JHTML::_( 'image', '/administrator/components/com_sectionex/img/sectionex.png', 'Example Image' ); ?><br />&nbsp;<br />&nbsp;
	</li>
	
	<li><a name="3_examples_2"></a><h3>Output with expandable descriptions</h3>
	<?php  echo JHTML::_( 'image', '/administrator/components/com_sectionex/img/sectionex2.png', 'Example Image' ); ?>
	</li>
</ul>



<br />&nbsp;
<a name="4_behind_the_scenes"></a>
<h2>4) Behind the Scenes</h2>
<p>..or why the select menu item type is called "SectionEx-><b>Category-></b>Section-Category-Article List" instead of "SectionEx-><b>Section-></b>Section-Category-Article" or something more adequate. After all we are displaying a section, aren't we? Well.. it turns out that there is a good reason for such a naming.</p>

<p>As I started to write SectionEx I thought it was only about one or two simple SQL selects and about generating an HTML table. It  turned out I was wrong. The hardest part was to get the menu highlighted correctly and in the pathway (breadcrumbs) displayed something one would expect. The problem is that as soon as we click on a link to an article displayed in our SectionEx's list we transfer control to another component, the com_content this is (a default component installed with Joomla!). As component's and menus in Joomla! are heavily connected and dependent on each other the question is how to fool the framework so that it highlights our SectionEx menu item, although a com_content component is now active? And how about the pathway? Just to ensure we are all on the same page - after an article is selected we would like the following result:

<ol>
	<li>Our SectionEx menu should remain highlighted even if we display an article with com_content</li>
	<li>The pathway should look like this: Home -> SectionEx Menu -> Article Title</li>
</ol>

To be honest I almost gave up at this point. It was my first Joomla! component and actually web-development is not what I'm doing for living. Then, luckily, the solution turned out ridiculously easy. To fix the menu we simply need to append an ItemId=myMenuId to the end of the generated URLs for our articles. ItemId is the parameter that Joomla! uses to decide which menu is highlighted. The pathway part turns out to be similar easy once you look at "..\components\com_content\views\article\view.html.php". There you will find the following code: 

<pre>
function display($tpl = null)
{
	...
	switch ($menu->query['view'])
	{
		case 'section':
			$pathway->addItem($article->category, 'index.php?view=category&id='.$article->catslug);
			$pathway->addItem($article->title, '');
			break;
		<b>case 'category':</b>
			<b>$pathway->addItem($article->title, '');</b>
			break;
		}
	}
	...
}
</pre>

Oops? All we have to do to get the pathway rendered out correctly is name our view "<b>category</b>"? Yes, it is. In this case Joomla! does everything for us exactly the way we expect it. So while the chosen naming convention probably isn't the most logical one for a user we just say: <i>"Hey, forget about one confusing word as long as it makes our universe synchronized. And let's hope that future Joomla! updates wont break our simple rules used in SectionEx."</i> 
</p>


<br />&nbsp;<br />&nbsp;
<a name="5_faq"></a>
<h2>5) FAQ</h2>
<ol>
<li>
	<b>How can I propagate SectionEx URLs to the entire Joomla! framework? I would like them to be generated on the FrontPage, for the Latest News module, and so on.</b> </p><p>Riccardo Budini provided a great trick and explanation on how to achieve this. It will take you less than 5 minutes. Just check his article at: <a href="http://www.provisum-studio.com/sectionex-urls.pdf">http://www.provisum-studio.com/sectionex-urls.pdf</a></p><p>
</li>

<li><b>My Print and PDF Icons don't wotk with SecionEx if SEO is enabled. How can I fix this?</b></p><p> Unfortunately you will have to add a few lines to the Joomla! core code.  Go to "..\components\com_content\router.php". There you will see the "ContentBuildRoute" function. Just add the following few lines at the beginning: 
	<pre>function ContentBuildRoute(&$query) 
{  
	 // ugly hack for SectionEx
	 // the following lines will make your PDF and Print Icons sing again :)

	 <b>$menus = &JSite::getMenu();     
	 $myMenuItem  = $menus-&gt;getActive();     
	 if (strcmp($myMenuItem-&gt;component, "com_sectionex") == 0)     
		 $myMenuItem-&gt;component = "com_content";</b>

	 // end of SectionEx hack       
... 
} </pre>

I don't like this solution but I couldn't find anything better that would be elegant and simple enough. If you FIND a better solution then please don't hesitate and drop me a line.
</li>
</ol>


<br />&nbsp;<br />
<a name="6_share_link"></a>
<h2>6) Share Your Link</h2>
<p>You became a happy SectionEx user? Would it bother you to share your link with me?
<br />It's nothing special. I'm just curious about how you use SectionEx. </p>

<br />&nbsp;
<a name="7_final_note"></a>
<h2>7) Final Note</h2>
<p>If you like SectionEx a comment and a vote on <a href="http://extensions.joomla.org/">http://extensions.joomla.org/</a> will be appreciated. Hey, after all you got a nice written and working component for free. A vote will take you 5 seconds and even a registration not more than 5 minutes. Compare those 5 minutes to several days that I spent developing SectionEx for my site. You agree that 5 minutes is a very fair price, don't you?</p>

<p>For those fellows who don't like SectionEx: There is a nice button called "Uninstall". Get rid of your SectionEx frustrations once and for all.</p>
</body></html>
