<?php
/**
* SectionEx global helper routines
*
 * @version		1.50
 * @package 	SectionEx
 * @copyright	Copyright (C)  2008, By Robert Kuster. All rights reserved.
 * @link                http://www.joomla.rkuster.com 
 * @license		GNU/GPL, see LICENSE.php
 */


// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * SectionEx global helpers
 *
 * @static
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class RkHelper
{
	function getIdOfActiveMenu()
	{
		$menus = &JSite::getMenu();
		$myMenuItem  = $menus->getActive();

		// -> is there any active menu?
		if ($myMenuItem != null)
			return $myMenuItem->id;
			
		return "0";
	}
	
	function getPrefixFoxStateVariables($bSessionWide = 0)
	{
		// bSessionWide = 0  -->> menu specific prefix
		// bSessionWide = 1  -->> session wide prefix
		$keyPrefix = 'com_sectionex.';
		if ($bSessionWide == 0)
		{
			$keyPrefix .= "id_".RkHelper::getIdOfActiveMenu().".";
		}
		return $keyPrefix;
	}
	
	
	function showSectionListToUser()
	{
		global $mainframe;
		$params 	= &$mainframe->getParams();		
		$section_list = $params->get('se_section_list');
		
		$result = str_replace(" ", "", $section_list);
		if (strlen($result) > 0)
		{	// if there are any other characters than [0-9], or "," or " " 
			// -> the given list is invalid -> don't display anything
			$valid_chars = array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ",", " ");
			$result = str_replace($valid_chars, "", $section_list);
			return (strlen($result) == 0);	
		}
		
		// -> empty string -> nothing to display
		return false;
	}
}
